<?php
/**
 * @category   Newsroom
 * @package    Newsroom_Whitepaper
 * @author     dushyantjoshia@gmail.com
 * @copyright  This file was generated by using Module Creator(http://code.vky.co.in/magento-2-module-creator/) provided by VKY <viky.031290@gmail.com>
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

namespace Newsroom\Whitepaper\Block;

use Magento\Framework\View\Element\Template\Context;
use Newsroom\Whitepaper\Model\WhitepaperFactory;

/**
 * Whitepaper List block
 */
class WhitepaperListData extends \Magento\Framework\View\Element\Template {
	/**
	 * @var Whitepaper
	 */
	protected $_whitepaper;
	public function __construct(
		\Magento\Framework\Stdlib\DateTime\DateTimeFactory $dateTimeFactory,
		Context $context,
		WhitepaperFactory $whitepaper
	) {
		$this->dateTimeFactory = $dateTimeFactory;
		$this->_whitepaper = $whitepaper;
		parent::__construct($context);
	}
	public function getFormatDate() {
		$dateModel = $this->dateTimeFactory->create();
		return $dateModel->gmtDate('j F Y');
	}
	public function _prepareLayout() {
		$this->pageConfig->getTitle()->set(__('White Paper'));

		if ($this->getWhitepaperCollection()) {
			$pager = $this->getLayout()->createBlock(
				'Magento\Theme\Block\Html\Pager',
				'newsroom.whitepaper.pager'
			)->setAvailableLimit(array(5 => 5, 10 => 10, 15 => 15))->setShowPerPage(true)->setCollection(
				$this->getWhitepaperCollection()
			);
			$this->setChild('pager', $pager);
			$this->getWhitepaperCollection()->load();
		}
		return parent::_prepareLayout();
	}

	public function getWhitepaperCollection() {
		$page = ($this->getRequest()->getParam('p')) ? $this->getRequest()->getParam('p') : 1;
		$pageSize = ($this->getRequest()->getParam('limit')) ? $this->getRequest()->getParam('limit') : 5;

		$whitepaper = $this->_whitepaper->create();
		$collection = $whitepaper->getCollection();
		$collection->addFieldToFilter('status', '1');
		//$whitepaper->setOrder('whitepaper_id','ASC');
		$collection->setPageSize($pageSize);
		$collection->setCurPage($page);

		return $collection;
	}

	public function getPagerHtml() {
		return $this->getChildHtml('pager');
	}
}